package com.citygis.impl;

import com.citygis.mapper.TongJiMapper;
import com.citygis.pojo.Tab_log2;
import com.citygis.serivce.TongJiService;
import lombok.Synchronized;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

@Service
public class TongJiServiceImpl implements TongJiService {

    @Resource
    TongJiMapper tongJiMapper;

    @Override
    @Scheduled(cron = "0 * * * *")
    public void getErrorCount() {
        List<Tab_log2> tabLog2s = tongJiMapper.getTabLog();

        List<Tab_log2> collect = new ArrayList<>();

        collect = tabLog2s.stream()
                .filter(tabLog2 -> !tabLog2.getStatus().equals("HTTP/1.1 200"))
                .collect(Collectors.toList());

        System.out.println("请求失败");
        collect.forEach(System.out::println);
    }

    @Scheduled(cron = "0 * * * *")
    @Override
    public void getSucceesCount() {
        List<Tab_log2> tabLog2s = tongJiMapper.getTabLog();

        List<Tab_log2> collect = new ArrayList<>();
        collect = tabLog2s.stream()
                .filter(tabLog2 -> tabLog2.getStatus().equals("HTTP/1.1 200"))
                .collect(Collectors.toList());

        System.out.println("请求成功");
        collect.forEach(System.out::println);
    }

    @Scheduled(cron = "0 * * * *")
    @Override
    public void getResponseTimeBig() {
        List<Tab_log2> tabLog2s = tongJiMapper.getTabLog();

        List<Tab_log2> collect = new ArrayList<>();
        collect = tabLog2s.stream()
                .filter(tabLog2 -> tabLog2.getResponseTime() != null && Integer.parseInt(tabLog2.getResponseTime()) >= 1000)
                .collect(Collectors.toList());

        System.out.println("响应时间大于1s");
        collect.forEach(System.out::println);
    }

    @Scheduled(cron = "0 * * * *")
    @Override
    public void getResponseTime() {
        List<Tab_log2> tabLog2s = tongJiMapper.getTabLog();

        List<Tab_log2> collect = new ArrayList<>();
        collect = tabLog2s.stream()
                .filter(tabLog2 -> tabLog2.getResponseTime() != null && Integer.parseInt(tabLog2.getResponseTime())  < 1000)
                .collect(Collectors.toList());

        System.out.println("响应时间小于1s");
        collect.forEach(System.out::println);
    }


    @Override
    @Scheduled(cron = "* * * * *")
    public void getCount() {
        Integer count = tongJiMapper.getCount();
        System.out.println("数量为--->" + count);
    }


}
